#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int *tirage(int nombre, int min, int max)
{
	int *tabelems, *ret, i, indice, maxi = max - min;
	if(min >= max || nombre > maxi + 1 || nombre < 1)
		return NULL;
	tabelems = malloc((maxi + 1) * sizeof(int));
	ret = malloc(nombre * sizeof(int));
	for(i = 0; i < maxi + 1; i++)
		tabelems[i] = i + min;
	for(i = 0; i < nombre; i++){
		indice = rand() % (maxi + 1);
		ret[i] = tabelems[indice];
		tabelems[indice] = tabelems[maxi];
		maxi--;
	}
	free(tabelems);
	return ret;
}

int main()
{
	int i,j,*tab;
	int nb = 7;
	srand(time(NULL));
	for(j = 0; j < 10; j++) 
	{
		if((tab = tirage(nb, 1, 49))) 
		{
			printf("Tirage %2d :", j + 1);
			for(i = 0; i < nb; i++)
				printf("  %d", tab[i]);
			printf("\n");
			free(tab);
		}
	}
	return 0;
}

/*!F
	Avant tout, merci  Magma pour avoir post cet algorithme sur le site du zro.

	C'est un algorithme fort lgant que je voulais conserver. 

	Le concept est le cas suivant : Considrons le jeu du loto : parmi 49 numros, on en tire 7.
	Evidemment, toute la difficult est qu'on ne veut pas tirer plusieurs fois le mme.

	Algorithme bourrin
	------------------
	On fait un for sur chaque numro  tirer, et pour chaque numro tir, on vrifie tous les prcdents en imbriquant un while jusqu' ce qu'on en trouve un 
	qui soit libre.
	Complexit du truc : n. Alors pour 7 numros, a va. Mais si je veux 1 million de numros, la, on souffre...

	Algorithme un peu moins bourrin
	-------------------------------
	On crit tous les nombres possibles dans un tableau. Concrtement, dans mon cas, je fais un tableau de 49 lments, dans lequel j'cris 1,2,3,4,...,48,49
	Puis je vais swapper au random 2 lments au hasard, et cela X fois. A la fin, on ne prend que les N lments souhaits.
	On a un jeu de carte trier : a force d'changer les cartes 2 par 2 au hasard, on finit par avoir un jeu mlang.
	Mais il faut que X soit grand, voir bien plus grand que N. Complexit X donc.

	Algorithme lgant (celui prsent dans le programme)
	-----------------------------------------------------
	Pareil qu'au dessus, je prpare un tableau tab de 49 lments : 1,2,3,4,...,48,49
	Mais cette fois, je vais crer mon tableau ret de N lments, et le remplir dans l'ordre.
	Pour la case 0 de ret, je prends un indice dans le tableau tab, ce sera mon premier lment.
	L'astuce consiste ensuite  remplacer l'lment tir par celui de la fin, et de rduire la taille du tableau, pour tre sur de ne pas le reprendre.

	Exemple :
	Je choisis l'index 4. 
	Donc ret[0] = 4;
	Puis je mets le dernier lment (49)  la place, donc j'crase le 4 : je suis sur que je ne le reprendrai pas.
	Le tableau devient :

	1,2,3,49,5,6,....,47,48,49

	On a deux fois 49, sauf que pour la prochaine itration, je considre le tableau avec un lment de moins, donc 1,2,3,49,5,6,....,47,48

	Nous avons un bel algo de mlange de complexit n, bien plus rapide que les autres algos du dessus.
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Tableau de nombres alatoires sans doublons.
titreE: Random numbers array, without duplicate.
meta: C;Tableau de nombres alatoires sans doublons.
metaE: C;random array without duplicate
desc : Un algorithme rapide pour crer un tableau alatoire sans doublons.
descE : A quick algorithm to male a random arrays without duplicate.
cle  : rand
*/
